/**
 * Simple Read
 * 
 * Прочитать данные из последовательного порта и изменить цвет прямоугольника,
 * когда переключатель, подключённый к плате Wiring или Arduino, нажат и отпущен.
 * Этот пример работает с нижеприведённой программой Wiring / Arduino.
 */


import processing.serial.*;

String portname = "/dev/tty.usbserial-A4001qa8";  // или "COM8"
Serial port;  // Создать объект класса Serial

int val=100;  // Данные, полученные из последовательного порта, со
	      // значением по умолчанию

void setup() 
{
  size(400, 400);
  
  colorMode(HSB, 255);
  ellipseMode(CENTER);   // рисовать из центра
  noStroke();
  frameRate(30);
  smooth();

  // Открыть порт, к которому подключена плата
  port = new Serial(this, portname, 19200);
}

void draw()
{
  if (port.available() > 0) {  // Если есть данные,
    val = port.read();         // прочитать их и сохранить в переменной
  }
  background(99);
  // Нарисовать фигуру
  fill(val,255,255);  // мы в режиме HSB, так что первая величина - цвет
  ellipse(width/2, height/2, 250,250);
}

