/* 
 * Serial RGB LED
 * ---------------
 * Команды через последовательный порт управляют яркостью 
 * красного, зелёного и синего светодиодов 
 *
 * Структура команды: "<colorCode><colorVal>", где "colorCode" -
 * символ "r","g", или "b" и "colorVal" - число между 0 и 255.
 * Напр. "r0" выключает красный светодиод.  
 *      "g127" делает яркость зелёного светодиода средней
 *      "b64"  делает яркость синего светодиода 1/4 от полной
 *
 * Created 18 October 2006
 * copyleft 2006 Tod E. Kurt <tod@todbot.com
 * http://todbot.com/
 */

char serInString[30];  // массив, в котором будут храниться разные байты строки. 30=30символов;
                        // -> вы обязаны указать, какой длины массив, иначе программа не будет
			// работать, как надо 
char colorCode;
int colorVal;

int redPin   = 9;   // Красный светодиод, подключён на цифровой пин 9
int greenPin = 10;  // Зелёный светодиод, подключён на цифровой пин 10
int bluePin  = 11;  // Синий светодиод, подключён на цифровой пин 11

void setup() {
  pinMode(redPin,   OUTPUT);   // сделать пины выходами
  pinMode(greenPin, OUTPUT);   
  pinMode(bluePin,  OUTPUT);
  Serial.begin(19200);
  analogWrite(redPin,   127);   // сделать их всех средней яркости
  analogWrite(greenPin, 127);   // сделать их всех средней яркости
  analogWrite(bluePin,  127);   // сделать их всех средней яркости
  Serial.println("enter color command (e.g. 'r43') :");  
}

void loop () {
  //прочитать значение из последовательного порта и сделать строку из прочитанного
  readSerialString(serInString);
    
  colorCode = serInString[0];
  if( colorCode == 'r' || colorCode == 'g' || colorCode == 'b' ) {
    colorVal = atoi(serInString+1);
    Serial.print("setting color ");
    Serial.print(colorCode);
    Serial.print(" to ");
    Serial.print(colorVal);
    Serial.println();
    serInString[0] = 0;                   // показывает, что эта строка уже использована
    if(colorCode == 'r') 
      analogWrite(redPin, 255-colorVal);
    else if(colorCode == 'g')
      analogWrite(greenPin, 255-colorVal);
    else if(colorCode == 'b')
      analogWrite(bluePin, 255-colorVal);
  }
  
  delay(100);  // немного подождать новых данных из последовательного порта
}

//считывает строку из последовательного порта и хранит её в массиве
//переменная с массивом уже должна быть заведена
void readSerialString (char *strArray) {
  int i = 0;
  if(!Serial.available()) {
    return;
  }
  while (Serial.available()) {
    strArray[i] = Serial.read();
    i++;
  }
  strArray[i] = 0;  // показывает конец строки
}

