/*
 * Serial Read Blink
 * -----------------
 * Turns on and off a light emitting diode(LED) connected to digital  
 * pin 13. The LED will blink the number of times given by a 
 * single-digit ASCII number read from the serial port.
 *
 * Created 18 October 2006
 * copyleft 2006 Tod E. Kurt <tod@todbot.com>
 * http://todbot.com/
 * 
 * основан на примере "serial_read_advanced"
 */

int ledPin = 13;   // выбор пина для светодиода
int val = 0;       // переменная для хранения данных из последовательного порта

void setup() {
  pinMode(ledPin,OUTPUT);    // объявить светодиод выходом
  Serial.begin(19200);        // подключиться к последовательному порту
  Serial.println("Welcome to SerialReadBlink!");
}

void loop () {
  val = Serial.read();      // прочитать значение с последовательного порта 

  // если величина - число из одной цифры, мигнуть светодиодом столько раз
  if (val > '0' && val <= '9' ) {
    val = val - '0';       // преобразовать из символа в число
    for(int i=0; i<val; i++) {
      Serial.println("blink!");
      digitalWrite(ledPin,HIGH);
      delay(150);
      digitalWrite(ledPin, LOW);
      delay(150);
    }
  }
}

